#include <stdio.h>
#include <share.h>
#include <string.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>


typedef char * LPSTR;


#define CONFIGBUFSIZE	128


int	PutConfigString(LPSTR filename, LPSTR section, LPSTR name, LPSTR val)
{
	char cfbuffer[CONFIGBUFSIZE];
  char currentsection[CONFIGBUFSIZE] = "";
	FILE *configfile;
	char outfilename[256];
	FILE *outfile;
	int stored = 0;
        int i;

	// open the config file
	configfile = _fsopen(filename, "rt", SH_DENYWR);

  if (!configfile)  return 1;

	// make out file name
	{
		char *dotpos;
		char *dirpos;

		strcpy(outfilename, filename);
		dotpos = strrchr(outfilename, '.');
		dirpos = strrchr(outfilename, '\\');
		if (dotpos == NULL) {
			strcat(outfilename, ".$$$");
		} else if (dotpos > dirpos) {
                	strcpy(dotpos, ".$$$");
		} else {
                	strcat(outfilename, ".$$$");
		}
	}

	// open the out file
	outfile = _fsopen(outfilename, "wt", SH_DENYRW);

	// read each line
	while (configfile != NULL && !feof(configfile)) {
		if (fgets(cfbuffer, CONFIGBUFSIZE, configfile)==NULL)
			break;
		// remove cr/lf and trailing spaces
		i = strlen(cfbuffer);
		while (i>=0 && strchr("\r\n \t", cfbuffer[i]) != NULL) {
			cfbuffer[i]=0;
			i--;
		}
		// if blank line
		if (strlen(cfbuffer) == 0)
                	continue;
		// if line is section header
		if (cfbuffer[0] == '[') {
			// if last section was requested section
                        if (!stored && strcmpi(section, currentsection) == 0) {
				// write new line
				fprintf (outfile, "%s=%s\n", name, val);
				stored = 1;
			}
			// write section header
			fputs("\n", outfile);
			fputs(cfbuffer, outfile);
			fputs("\n", outfile);
			i = 1;
			while (cfbuffer[i] && cfbuffer[i] != ']')
				i++;
			cfbuffer[i] = 0;
			strcpy(currentsection, &(cfbuffer[1]));
		} else if (strcmpi(section, currentsection) == 0) {
		// if this is requested section
			char namebuf[CONFIGBUFSIZE];

			strcpy(namebuf, cfbuffer);
			// find the name
                        i = 0;
			while (namebuf[i] && namebuf[i] != '=')
				i++;
			namebuf[i] = 0;
			i--;
			while (i > 0 && (namebuf[i] == ' ' || namebuf[i] == '\t')) {
        	        	namebuf[i] = 0;
				i--;
			}
			// if this is requested name
			if (strcmpi(name, namebuf) == 0) {
				// write new line
				fprintf (outfile, "%s=%s\n", name, val);
				stored = 1;
			} else {
				// write old line
				fputs(cfbuffer, outfile);
                                fputs("\n", outfile);
			}
		} else {
			// write old line
			fputs(cfbuffer, outfile);
			fputs("\n", outfile);
		}
        }
	// if section was not found or end of file was encountered
	if (! stored ) {
		if (strcmpi(section, currentsection) != 0) {
			// write new section
			fprintf (outfile, "\n[%s]\n", section);
                }
		// write new line
		fprintf (outfile, "%s=%s\n", name, val);
	}

	// close both files
	fclose(outfile);
	if (configfile != NULL)
		fclose(configfile);

	// replace old config file with new out file
	unlink(filename);
        rename(outfilename, filename);

	return 0;
}


int main(int argc,char *argv[])
{
  if (argc!=5) {
    printf("SETINI -- Writes to INI style text file.\n");
	  printf("Syntax:\n  SETINI filename section key value\n\n");

	  printf("Example:\n  SETINI c:\\windows\\system.ini boot shell \"newshell.exe\"\n");
	  exit(0);
	  }

  if (PutConfigString(argv[1],argv[2],argv[3],argv[4])) {
    printf("Cannot write to file %s\n",argv[1]);
    return 1;
    }

  return 0;
}
